/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package razenibarev;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;
import java.util.Random;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author petr
 */
public class AppFrame extends JFrame {

    private Color[] color;
    private JButton generate;
    private JButton sort;
    private JPanel[] panels;

    public AppFrame() {
        super("Řazení barev");
        color = new Color[10];
        panels = new JPanel[color.length];

        generate = new JButton("Generovat barvy");
        sort = new JButton("Seřadit barvy");
        for(int i = 0; i < panels.length; i++) {
            panels[i] = new JPanel();
        }

        JPanel buttons = new JPanel();
        buttons.add(generate);
        buttons.add(sort);
        add(buttons,BorderLayout.NORTH);

        JPanel paleta = new JPanel();
        paleta.setLayout(new GridLayout(1,10));

        for(int i = 0; i < panels.length; i++) {
            paleta.add(panels[i]);
        }
        add(paleta);

        setSize(new Dimension(350, 300));
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


        generate.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
               AppFrame.this.generateColors();
            }
        });

        sort.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                AppFrame.this.sortColors();
            }
        });
    }

    private void generateColors() {
        Random rand = new Random();
        for (int i = 0; i < color.length; i++) {
            color[i] = new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256));
            panels[i].setBackground(color[i]);
        }
        repaint();
    }

    private void sortColors() {
        Arrays.sort(color, new ColorComparator());
        for (int i = 0; i < color.length; i++) {
            panels[i].setBackground(color[i]);
        }
        repaint();
    }

    public static void main(String[] args) {

        JFrame app = new AppFrame();
        app.setVisible(true);
    }
}
